--[[
Copyright 2009-2021 João Cardoso
Blitz is distributed under the terms of the GNU General Public License (or the Lesser GPL).
This file is part of Blitz.

Blitz is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Blitz is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Blitz. If not, see <http://www.gnu.org/licenses/>.
--]]

local ADDON, Addon = ...
local Server = Addon:NewModule('Server')
Server.SelectActive = C_GossipInfo.SelectActiveQuest or SelectGossipActiveQuest
Server.SelectAvailable = C_GossipInfo.SelectAvailableQuest or SelectGossipAvailableQuest
Server.NumActive = C_GossipInfo.GetNumActiveQuests or GetNumGossipActiveQuests
Server.NumAvailable = C_GossipInfo.GetNumAvailableQuests or GetNumGossipAvailableQuests

function Server.GetActive(i)
  if C_GossipInfo.GetActiveQuests then
    return C_GossipInfo.GetActiveQuests()[i].questID
  end

  return select(i*7, GetGossipActiveQuests())
end

function Server.GetAvailable(i)
  if C_GossipInfo.GetAvailableQuests then
    return C_GossipInfo.GetAvailableQuests()[i].questID
  end

  return select(i*8, GetGossipAvailableQuests())
end

function Server.IsComplete(id)
  if C_QuestLog.IsComplete then
    return C_QuestLog.IsComplete(id)
  end

  return select(6, GetQuestLogTitle(GetQuestLogIndexByID(id))) == 1
end

function Server.GetItem(kind, i)
	return strmatch(GetQuestItemLink(kind, i) or '', 'item:(%d+)')
end
